/*****************************************************************************
 *- Utility Function Declarations (Non-Exported) ----------------------------*
 *****************************************************************************/

#include <visa.h>

#define RSEMI_NAN                 9.91e+37
#define RSEMI_NAN_VI_INT32        0x80000000

ViStatus rsemi_InitAttributes (ViSession vi);
ViStatus rsemi_DefaultInstrSetup (ViSession openInstrSession);
ViStatus rsemi_CheckStatus (ViSession vi);
ViStatus rsemi_WaitForOPC (ViSession vi, ViUInt32 maxTime);
ViInt32 rsemi_StringIndex(ViString array[], ViChar buff[]); 
ViStatus rsemi_invalidViInt32Range (ViSession instrSession, ViInt32 val, ViInt32 min, ViInt32 max);
ViStatus rsemi_invalidViReal64Range (ViSession instrSession, ViReal64 val, ViReal64 min, ViReal64 max);
ViStatus rsemi_SetOPCTimeout(ViSession   instrSession, ViInt32 timeout);
ViStatus rsemi_GetOPCTimeout(ViSession   instrSession, ViInt32 *timeout);
ViStatus rsemi_CheckBeforeRead (ViSession instrSession, ViUInt32 maxTime);
void rsemi_SWAP_32(unsigned char *data, long points);  
ViStatus rsemi_dataReadTrace (ViSession instrSession,
                                 ViInt32 window,
                                 ViString resultsType, 
                                 ViInt32 arrayLength, 
                                 /*@out@*/ViReal64 _VI_FAR traceData[],
                                 ViPInt32 noofPoints);
ViStatus rsemi_readDataBlock (ViSession instrSession,
                                  /*@out@*/ViChar **outputBuffer, /*@out@*/ViUInt32 *byteCount);
ViStatus rsemi_GetAttributeRepCapName (ViSession instrSession,
                                ViUInt32 attributeID,
                                ViString repCapNameId,
                                ViInt32 value,
                                ViInt32 bufferSize,
                                ViChar _VI_FAR repCapName[]);
ViStatus rsemi_ParseLimitLineCatalog(ViChar *buffer, ViInt32 size, ViChar *catalogList, ViInt32 *nbValues);
ViStatus rsemi_ClearBeforeRead (ViSession instrSession);
ViStatus rsemi_ParseCatalog(ViChar *buffer, ViInt32 size, ViChar *catalogList, ViInt32 *nbValues);
ViStatus _VI_FUNC rsemi_dataReadTraceIQ (ViSession   instrSession,
                                            ViInt32     bufferSize,
                                            ViPInt32    noofPoints,
                                            /*@out@*/ViReal64 _VI_FAR realPartsI[],
                                            /*@out@*/ViReal64 _VI_FAR imaginaryPartsQ[]);
ViStatus rsemi_dataReadTraceOnly (ViSession instrSession,
                                  ViInt32 arrayLength, 
                                  /*@out@*/ViReal64 _VI_FAR traceData[],
                                  ViPInt32 noofPoints);
ViStatus rsemi_CreatePeakRepCap (ViSession instrSession, ViInt32 peak, ViChar repCap[]);
